import { IResource, Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnVPCCidrBlock, IVpc } from 'aws-cdk-lib/aws-ec2';
import { IConstruct } from 'constructs';
import { ICidrAssignment } from './lib/cidr-assignment';
export interface IVpcCidrBlock extends IResource {
    readonly vpcCidrBlockAssociationId: string;
    readonly vpcCidrBlockCidr: string;
}
declare abstract class VpcCidrBlockBase extends Resource implements IVpcCidrBlock {
    abstract readonly vpcCidrBlockAssociationId: string;
    abstract readonly vpcCidrBlockCidr: string;
}
export interface VpcCidrBlockAttributes {
    readonly associationId: string;
    readonly cidr: string;
}
export interface VpcCidrBlockProps extends ResourceProps {
    readonly cidrAssignment: ICidrAssignment;
    readonly vpc: IVpc;
}
export declare class VpcCidrBlock extends VpcCidrBlockBase {
    static fromVpcCidrBlockAttributes(scope: IConstruct, id: string, attrs: VpcCidrBlockAttributes): IVpcCidrBlock;
    readonly vpc: IVpc;
    readonly resource: CfnVPCCidrBlock;
    readonly vpcCidrBlockAddressFamily: string;
    readonly vpcCidrBlockAssociationId: string;
    readonly vpcCidrBlockCidr: string;
    constructor(scope: IConstruct, id: string, props: VpcCidrBlockProps);
    private lookupCidrBlock;
}
export {};
